<?php

/**
* PHP versions 4 and 5
*
* LICENSE: This source file is subject to version 3.0 of the PHP license
* that is available through the world-wide-web at the following URI:
* http://www.php.net/license.  If you did not receive a copy of
* the PHP License and are unable to obtain it through the web, please
* send a note to license@php.net so we can mail you a copy immediately.
*
* @package    QuickTalk Guestbook
* @author     Philippe Vandenberghe <info@qt-cute.org>
* @copyright  2009-2012 The PHP Group
* @version    2.0 build:200901003
*/

session_start();
require_once('bin/qtg_init.php');

// INI

$intId  = -1;
$strName = '';
$intAge  = '';
$strFrom = '';
$strMail = '';
$strMsg  = '';
$strCode = '';
$bCol = $qtg_column_default;

if ( isset($_GET['v']) ) $_SESSION['qtgview']=$_GET['v'];
if ( isset($_GET['page']) ) { $limit = ($_GET['page']-1)*$qtg_page_size; $intPage=intval($_GET['page']); } else { $limit=0; $intPage=1; }
if ( isset($_SESSION['qtgview']) ) $bCol = ($_SESSION['qtgview']=='col');

// Map

if ( !empty($qtg_gkey) )
{ 
  include('qtg_map_lib.php');
  include(GetLang().'qtg_map.php');
  if ( !$qtg_separateform ) $qtg_separateform=true; // force separate form when map in used
  $strBodyAddOnunload='GUnload()';
}

// COUNT TOPICS

$oDB->Query( 'SELECT count(id) as countid FROM '.TABMESSAGE.' WHERE id>=0 AND visible="Y"' );
$row = $oDB->Getrow();
$intMessages = intval($row['countid']);

$pg_url='qtg_index.php';

// --------
// HTML START
// --------

include('qtg_p_header.php');

// TIPS WELCOME

echo '
<!-- tips -->
<table class="welcome" cellspacing="0">
<tr class="welcome">
<td class="welcome welcome_l">

<table class="wbox" cellspacing="0">
<tr class="wbox_u">
<td class="wbox_ul"></td>
<td class="wbox_uc"></td>
<td class="wbox_ur"></td>
</tr>
<tr class="wbox_m">
<td class="wbox_ml"></td>
<td class="wbox_mc">
<span class="welcome">';
if ( file_exists(GetLang().'qtg_welcome.txt') )
{
include(GetLang().'qtg_welcome.txt');
}
else
{
echo $L['Welcome'];
}
echo '
</span>
</td>
<td class="wbox_mr"></td>
</tr>
<tr class="wbox_l">
<td class="wbox_ll"></td>
<td class="wbox_lc"></td>
<td class="wbox_lr"></td>
</tr>
</table>

</td>
<td class="welcome welcome_c"></td>
<td class="welcome welcome_r">';
if ( $qtg_column_change ) echo '&nbsp;<a href="qtg_index.php?v=std" class="ico_view_std" title="',$L['View_std'],'">&nbsp;</a>&nbsp;<a href="qtg_index.php?v=col" class="ico_view_col" title="',$L['View_col'],'">&nbsp;</a>';
if ( $qtg_home<>'' ) echo '&nbsp;<a href="',$qtg_home,'" class="ico_home" title="',$L['Home'],'">&nbsp;</a>';
echo '</td>
</tr>
</table>
';

if ( $qtg_actif )
{
  if ( $qtg_separateform )
  {
    echo '<div class="signbutton"><a class="signbutton" href="qtg_msg_add.php">',$L['Sign'],'</a></div>';
  }
}

// PAGER

$pager = MakePager('qtg_index.php?f=1',$intMessages,$qtg_page_size,$intPage,$L);

if ( $pager!='' )
{
echo '
<!-- pager -->
<table class="pager" cellspacing="0" cellpadding="0">
<tr class="pager_top">
<td class="pager_top">',$L['Page'],$pager,'</td>
</tr>
</table>
';
}

// QUERY

$oDB->Query( LimitSQL($oDB->type,'* FROM '.TABMESSAGE.' WHERE id>=0 AND visible="Y"','issuedate DESC',$limit,$qtg_page_size,$intMessages) );

// DISPLAY

if ( $bCol )
{
echo '
<!-- 2 columns start -->
<table class="column" cellspacing="0">
<colgroup span="2"><col style="width:50%"></col><col style="width:50%"></col></colgroup>
<tr class="column"><td class="column">
<!-- 2 columns start -->
';
}

$iCol = 1;
while($row=$oDB->Getrow())
{
  $oPost = new cPost($row);

  if ( !empty($qtg_gkey) ) {
  if ( $oPost->x!=0 && $oPost->y!=0 ) {

    $strPname = substr(QTconv($oPost->name,'1'),0,25);
    $strPlink = '<a href="http://maps.google.com?q='.$oPost->y.','.$oPost->x.'+('.$strPname.')" class="small" title="'.$L['map']['In_google'].'" target="_blank">[G]</a>';
    $strPtxt = IQTbbc($oPost,'drop',' ',150,null,null,$qtg_skin,$intPage).($qtg_use_from && !empty($oPost->postfrom) ? '<br/>'.QTconv($oPost->postfrom,'1') : '');
    $oMapPoint = new cMapPoint(floatval($oPost->y),floatval($oPost->x),QTconv($oPost->name,'-3'),'<div class="ginfo"><b>'.QTconv($strPname,'2').'</b><br/>'.$strPtxt.'<br/>'.QTconv(QTdatestr($oPost->issuedate,'$','$',true),'2').' '.$strPlink.'</div>',false);
    if ( isset($qtg_gsymbol) ) $oMapPoint->icon = $qtg_gsymbol;
    if ( isset($qtg_gshadow) ) $oMapPoint->shadow = $qtg_gshadow;
    if ( isset($qtg_gprinticon) ) $oMapPoint->printicon = $qtg_gprinticon;
    if ( isset($qtg_gprintshadow) ) $oMapPoint->printshadow = $qtg_gprintshadow;
    $arrExtData[$oPost->id] = $oMapPoint;

  }}

  // ------------
  include('qtg_msg_msg.php'); 
  // ------------

  if ( $_SERVER['REMOTE_ADDR']==$oDB->ip ) {
  if ( isset($_SESSION['qtg_beginedit']) && isset($_SESSION['qtg_endedit']) ) {
  if ( $oPost->issuedate >= date('YmdHis',$_SESSION['qtg_beginedit']) && $oPost->issuedate < date('YmdHis',$_SESSION['qtg_endedit']) ) {
    if ( time()+0 < $_SESSION['qtg_endedit'] )
    {
    echo '&nbsp;<a href="qtg_msg_edit.php?id=',$oPost->id,'">[',$L['Edit_my_message'],']</a>&nbsp;<a href="qtg_msg_del.php?id=',$oPost->id,'">[',$L['Delete_my_message'],']</a><br/><br/>';
    }
    else
    {
    unset($_SESSION['qtg_endedit']);
    unset($_SESSION['qtg_beginedit']);
    }
  }}}

  if ( $bCol )
  {
    if ( $iCol==1 ) echo '</td><td class="column">',N;
    if ( $iCol==2 ) echo '</td></tr><tr class="column"><td class="column">',N;
    $iCol++;
    if ( $iCol>2 ) $iCol=1;
  }
  
}

// end column layout
$iCol = 1;
if ( $bCol ) 
{
echo '
<!-- 2 columns end -->
</td>
</tr>
</table>
<!-- 2 columns end -->
';
}

if ( !empty($qtg_gkey) )
{ 
  if ( count($arrExtData)==0 )
  {
    echo '<div class="gmap_disabled">'.$L['map']['E_noposition'].'</div>';
  }
  else
  {
    //select zoomto (maximum 20 items in the list)
    if ( count($arrExtData)>1 )
    {
      $str = '<p class="gmap" style="margin:0 0 4px 0"><a class="gmap" href="javascript:void(0)" onclick="zoomToFullExtend(); return false;">'.$L['map']['zoomtoall'].'</a> | '.$L['map']['jumpto'].' <select class="gmap" id="zoomto" name="zoomto" size="1" onchange="map.setCenter(eval(this.value));">';
      $str .= '<option class="small_gmap" value="new GLatLng('.QTgety($qtg_gcenter).','.QTgetx($qtg_gcenter).')"> </option>';
      $i=0;
      foreach($arrExtData as $intKey=>$oMapPoint)
      {
      $str .= '<option class="small_gmap" value="new GLatLng('.$oMapPoint->y.','.$oMapPoint->x.')">'.$oMapPoint->title.'</option>';
      $i++; if ( $i>20 ) break;       
      }
      $str .= '</select></p>';
    }

    echo '
    <div class="gmap">
    ',( count($arrExtData)>1 ? $str :'' ),'
    <div id="map_canvas" style="width:100%; height:350px;"></div>
    <p class="gmap" style="margin:4px 0 0 0">',sprintf($L['map']['items'],strtolower( LangS('Message',count($arrExtData))),strtolower(LangS('Message',$intMessages)) ),'</p>
    </div>
    ';
  }
}

if ( $pager!='' )
{
echo '
<!-- pager -->
<table class="pager" cellspacing="0" cellpadding="0">
<tr class="pager_bot">
<td class="pager_bot">',$L['Page'],$pager,'</td>
</tr>
</table>
';
}

if ($qtg_checkip)
{
  if ( strstr($qtg_checkip_list,($_SERVER['REMOTE_ADDR'])) )
  {
    echo '<p style="text-align:center">',$L['E_ip_denied'],'</p>';
    $qtg_actif=false;
  }
}

if ($qtg_actif)
{
  if ($qtg_separateform)
  {
    if ( $intMessages>2 ) echo '<div class="signbutton"><a class="signbutton" href="qtg_msg_add.php">',$L['Sign'],'</a></div>';
  }
  else
  {
    $oPost = new cPost();
    $formaction = 'qtg_msg_add.php';
    include('qtg_form_msg.php');
  }
}
else
{
  echo '<p style="text-align:center">';
  if ( file_exists(GetLang().'qtg_stop.txt') ) { include(GetLang().'qtg_stop.txt'); } else { echo 'Guestbook temporary closed. Please wait...'; }
  echo '</p>';
}

// --------
// HTML END
// --------

if ( !empty($qtg_gkey) )
{

  if ( count($arrExtData)>0 )
  {
    $y = floatval(QTgety($qtg_gcenter));
    $x = floatval(QTgetx($qtg_gcenter));

    // center on the first item
    foreach($arrExtData as $intKey=>$oMapPoint)
    {
      if ( !empty($oMapPoint->y) && !empty($oMapPoint->x) )
      {
      $y=$oMapPoint->y;
      $x=$oMapPoint->x;
      break;
      }
    }
  
$strFooterAddScript = QTgmapscript($qtg_gkey).'
<script type="text/javascript">
<!--
'.QTgmappoints(false,$y,$x,'click',$arrExtData).'
mapload();
-->
</script>
';

  } 
  else
  {

$strFooterAddScript = '
<script type="text/javascript">
<!--
function GUnload() { return true; }
-->
</script>
';

  }
 
}

include('qtg_p_footer.php');

?>