<?php

/**
* PHP versions 4 and 5
*
* LICENSE: This source file is subject to version 3.0 of the PHP license
* that is available through the world-wide-web at the following URI:
* http://www.php.net/license.  If you did not receive a copy of
* the PHP License and are unable to obtain it through the web, please
* send a note to license@php.net so we can mail you a copy immediately.
*
* @package    QuickTalk Guestbook
* @author     Philippe Vandenberghe <info@qt-cute.org>
* @copyright  2009-2012 The PHP Group
* @version    2.0 build:20091003
*/

session_start();

require_once('bin/qtg_init.php');
$strName = '';

$pg_url='qtg_login.php';

// --------
// SUBMITTED
// --------

if ( isset($_POST['ok']) )
{
  // CHECK FORM VALUE

  $strName = trim($_POST['title']); if ( get_magic_quotes_gpc() ) $strName = stripslashes($strName);
  if ( !QTislogin($strName,2) ) $error = $L['Username'].' '.$L['E_invalid'];

  $strPwd = trim($_POST['pwd']);
  if ( !QTispassword($strPwd,2) ) $error = $L['Password'].' '.$L['E_invalid'];

  // check login
  if ( empty($error) )
  {
    if ( ($strName!=$qtg_user) && ($strName!=$qtg_user_2) ) $error=$L['E_access_denied'];
  }
  // check pwd
  if ( empty($error) )
  {
    if ( ($strName==$qtg_user) && ($strPwd!=$qtg_pwd) ) $error=$L['E_access_denied'];
    if ( ($strName==$qtg_user_2) && ($strPwd!=$qtg_pwd_2) ) $error=$L['E_access_denied'];
  }

  // execute
  if ( empty($error) )
  {
  $_SESSION['qtgAuth'] = 'yes';
  include('qtg_p_header.php');
  echo '
  <div id="login">
  <h1>',$L['Login'],' ',$strName,'</h1>
  <p>&nbsp;</p>
  <table class="button" cellspacing="0">
  <tr class="button">
  <td class="button"><a id="exiturl" class="button" href="qtg_adm.php">',$L['Return_administration'],'</a></td>
  </tr>
  </table>
  </div>
  <script type="text/javascript">
  <!--
  setTimeout(\'window.location=document.getElementById("exiturl").href\',1000);
  -->
  </script>
  ';
  include('qtg_p_footer.php');
  exit;
  }
}

// LOGOUT

if ( isset($_GET['a']) ) {
if ( $_GET['a']=='out' ) {
  session_destroy();  
  require_once('bin/qtg_init.php');
  $_SESSION['qtgAuth']='N';
  include('qtg_p_header.php');  
  echo '
  <h1>',$L['Logout'],'</h1>
  <p>&nbsp;</p>',$qtg_back,'
  <script type="text/javascript">
  <!--
  setTimeout(\'window.location=document.getElementById("exiturl").href\',1000);
  -->
  </script>
  ';
  include('qtg_p_footer.php');
  exit;
}}

// --------
// START HTML
// --------

include('qtg_p_header.php');

echo '
<script type="text/javascript">
<!--
function ValidateForm(theForm)
{
  if (theForm.title.value.length==0) { alert(qtHtmldecode(\'',$L['E_mandatory'],': ',$L['Username'],'\')); return false; }
  if (theForm.pwd.value.length==0) { alert(qtHtmldecode(\'',$L['E_mandatory'],': ',$L['Password'],'\')); return false; }
  return null;
}
-->
</script>

<div id="login">
<h1>',$L['Login'],'</h1>
<table class="reply">
<tr class="reply">
<td class="reply">
<form method="post" action="qtg_login.php" onsubmit="return ValidateForm(this)">
<p class="form"><label for="title">',$L['Username'],'</label> <input type="text" id="title" name="title" size="20" maxlength="24" value="',$strName,'"/></p>
<p class="form"><label for="pwd">',$L['Password'],'</label> <input type="password" id="pwd" name="pwd" size="20" maxlength="24"/></p>
<p class="form">',( !empty($error) ? '<span class="error">'.$error.'</span> ' : ''),'<input type="submit" name="ok" value="',$L['Login'],'"/></p>
</form>
</td>
</tr>
</table>
<p>&nbsp;</p>',$qtg_back,'
</div>
';

// --------
// HTML END
// --------

echo '
<script type="text/javascript">
<!--
document.getElementById("title").focus();
if ( document.getElementById("title").value.length>1 ) { document.getElementById("pwd").focus(); }
-->
</script>
';

include('qtg_p_footer.php');

?>