<?php

/**
* PHP versions 4 and 5
*
* LICENSE: This source file is subject to version 3.0 of the PHP license
* that is available through the world-wide-web at the following URI:
* http://www.php.net/license.  If you did not receive a copy of
* the PHP License and are unable to obtain it through the web, please
* send a note to license@php.net so we can mail you a copy immediately.
*
* @package    QuickTalk Guestbook
* @author     Philippe Vandenberghe <info@qt-cute.org>
* @copyright  2009-2012 The PHP Group
* @version    2.0 build:20091003
*/

session_start();
require_once('bin/qtg_init.php');

$id = -1;
if ( isset($_POST['id']) ) $id = intval(trim($_POST['id']));
if ( isset($_GET['id']) ) $id = intval(trim($_GET['id']));
if ( $id<0 ) die('ID '.$L['E_invalid']);

$pg_url='qtg_msg_view.php';

// MAP

if ( !empty($qtg_gkey) )
{ 
  include('qtg_map_lib.php');
  include(GetLang().'qtg_map.php');
  $strBodyAddOnunload='GUnload()';
}

// --------
// HTML START
// --------

include('qtg_p_header.php');

if ( isset($_GET['del']) )
{
  if ( $_GET['del']=='Y' )
  {
  include(GetLang().'qtg_adm.php');
  include('qtg_adm_menu.php');
  $qtg_back='';
  echo "<h1>{$L['Deleting']}</h1>\n";
  }
}

if ( isset($_GET['page']) ) { $intPage=intval($_GET['page']); } else { $intPage=1; }

// DISPLAY

echo "<h1>{$L['Message']}</h1>\n";

echo "<!-- pager -->
&nbsp;
\n";

$oPost = new cPost($id);
$intMessages=1;

$qtg_show_size=null;

if ( !empty($qtg_gkey) ) { 
if ( $oPost->x!=0 && $oPost->y!=0 ) {

  $strPname = substr(QTconv($oPost->name,'1'),0,25);
  $strPlink = '<a href="http://maps.google.com?q='.$oPost->y.','.$oPost->x.'+('.$strPname.')" class="small" title="'.$L['map']['In_google'].'" target="_blank">[G]</a>';
  $strPtxt = IQTbbc($oPost,'drop',' ',150,null,null,$qtg_skin,$intPage,false).($qtg_use_from && !empty($oPost->postfrom) ? '<br/>'.QTconv($oPost->postfrom,'1') : '');
  $oMapPoint = new cMapPoint(floatval($oPost->y),floatval($oPost->x),QTconv($oPost->name,'-3'),'<div class="ginfo"><b>'.$strPname.'</b><br/>'.$strPtxt.'<br/>'.QTdatestr($oPost->issuedate,'$','$',true).' '.$strPlink.'</div>',false);
  if ( isset($qtg_gsymbol) ) $oMapPoint->icon = $qtg_gsymbol;
  if ( isset($qtg_gshadow) ) $oMapPoint->shadow = $qtg_gshadow;
  if ( isset($qtg_gprinticon) ) $oMapPoint->printicon = $qtg_gprinticon;
  if ( isset($qtg_gprintshadow) ) $oMapPoint->printshadow = $qtg_gprintshadow;
  $arrExtData[$oPost->id] = $oMapPoint;

}}

// ------------
include('qtg_msg_msg.php'); 
// ------------  

if ( isset($_GET['del']) )
{
  if ( $_GET['del']=='Y' )
  {
  echo '<table cellspacing="0" class="button" style="width:200px;"><tr><td class="button"><a href="qtg_adm_del.php?id=',$id,'"><b>',$L['Delete'],' !</b></a></td></tr></table>',N;
  }
}

if ( !empty($qtg_gkey) )
{ 
  if ( count($arrExtData)==0 )
  {
    echo '<div class="gmap_disabled">'.$L['map']['E_noposition'].'</div>';
  }
  else
  {
    //select zoomto (maximum 20 items in the list)
    if ( count($arrExtData)>1 )
    {
      $str = '<p class="gmap" style="margin:0 0 4px 0"><a class="gmap" href="javascript:void(0)" onclick="zoomToFullExtend(); return false;">'.$L['map']['zoomtoall'].'</a> | '.$L['map']['jumpto'].' <select class="gmap" id="zoomto" name="zoomto" size="1" onchange="map.setCenter(eval(this.value));">';
      $str .= '<option class="small_gmap" value="new GLatLng('.QTgety($qtg_gcenter).','.QTgetx($qtg_gcenter).')"> </option>';
      $i=0;
      foreach($arrExtData as $intKey=>$oMapPoint)
      {
      $str .= '<option class="small_gmap" value="new GLatLng('.$oMapPoint->y.','.$oMapPoint->x.')">'.$oMapPoint->title.'</option>';
      $i++; if ( $i>20 ) break;       
      }
      $str .= '</select></p>';
    }

    echo '
    <div class="gmap">
    ',( count($arrExtData)>1 ? $str :'' ),'
    <div id="map_canvas" style="width:100%; height:350px;"></div>
    <p class="gmap" style="margin:4px 0 0 0">',sprintf($L['map']['items'],strtolower( LangS('Message',count($arrExtData))),strtolower(LangS('Message',$intMessages)) ),'</p>
    </div>
    ';
  }
}

echo '
<!-- pager -->
&nbsp;
';

if ( isset($intPage) ) { $qtg_back = str_replace('href="qtg_index.php"','href="qtg_index.php?page='.$intPage.'"',$qtg_back); } 
echo $qtg_back;

// --------
// HTML END
// --------

if ( !empty($qtg_gkey) ) 
{ 
  if ( count($arrExtData)>0 )
  {
    $y = floatval(QTgety($qtg_gcenter));
    $x = floatval(QTgetx($qtg_gcenter));

    // center on the first item
    foreach($arrExtData as $intKey=>$oMapPoint)
    {
      if ( !empty($oMapPoint->y) && !empty($oMapPoint->x) )
      {
      $y=$oMapPoint->y;
      $x=$oMapPoint->x;
      break;
      }
    }

$strFooterAddScript = QTgmapscript($qtg_gkey).'
<script type="text/javascript">
<!--
'.QTgmappoints(false,$y,$x,'click',$arrExtData).'
mapload();
-->
</script>
';

  }
  else
  {

$strFooterAddScript = '
<script type="text/javascript">
<!--
function GUnload() { return true; }
-->
</script>
';

  }
}

include('qtg_p_footer.php');

?>